-- MySQL Script generated by MySQL Workbench
-- Tue Oct 12 23:26:50 2021
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema ct_trans
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema ct_trans
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `ct_trans` DEFAULT CHARACTER SET utf8 ;
USE `ct_trans` ;

-- -----------------------------------------------------
-- Table `ct_trans`.`student`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`student` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`student` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(150) NOT NULL,
  `cpf` INT(11) NOT NULL,
  `cnh` INT NOT NULL,
  `address` VARCHAR(45) NOT NULL,
  `addressNumber` INT NOT NULL,
  `cep` INT NOT NULL,
  `state` VARCHAR(45) NOT NULL,
  `city` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`role`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`role` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`role` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `employe_id` VARCHAR(45) NOT NULL,
  `intructor_id` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`employe`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`employe` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`employe` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(45) NOT NULL,
  `email` VARCHAR(100) NOT NULL,
  `nickname` VARCHAR(45) NOT NULL,
  `password` VARCHAR(45) NOT NULL,
  `role_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_role_id_idx` (`role_id` ASC) VISIBLE,
  CONSTRAINT `fk_role_id`
    FOREIGN KEY (`role_id`)
    REFERENCES `ct_trans`.`role` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`instructor`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`instructor` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`instructor` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `employe_id` INT NOT NULL,
  `instructor_name` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_employe_id_idx` (`employe_id` ASC) VISIBLE,
  CONSTRAINT `fk_employe_id`
    FOREIGN KEY (`employe_id`)
    REFERENCES `ct_trans`.`employe` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`course`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`course` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`course` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `instructor_id` INT NOT NULL,
  `name` VARCHAR(45) NOT NULL,
  `workload` INT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_instructor_id_idx` (`instructor_id` ASC) VISIBLE,
  CONSTRAINT `fk_instructor_id`
    FOREIGN KEY (`instructor_id`)
    REFERENCES `ct_trans`.`instructor` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`registration`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`registration` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`registration` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `curso_id` INT NOT NULL,
  `student_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_curso_id_idx` (`curso_id` ASC) VISIBLE,
  INDEX `fk_registration_student1_idx` (`student_id` ASC) VISIBLE,
  CONSTRAINT `fk_curso_id`
    FOREIGN KEY (`curso_id`)
    REFERENCES `ct_trans`.`course` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_registration_student1`
    FOREIGN KEY (`student_id`)
    REFERENCES `ct_trans`.`student` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`protocol`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`protocol` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`protocol` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `student_id` INT NOT NULL,
  `name` VARCHAR(100) NOT NULL,
  `description` TEXT(200) NOT NULL,
  `anex` VARCHAR(45) NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_student_id_idx` (`student_id` ASC) VISIBLE,
  CONSTRAINT `fk_student_id`
    FOREIGN KEY (`student_id`)
    REFERENCES `ct_trans`.`student` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`permissions`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`permissions` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`permissions` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `description` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`permissions_role`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`permissions_role` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`permissions_role` (
  `permissions_permissions_id` INT NOT NULL,
  `role_role_id` INT NOT NULL,
  PRIMARY KEY (`permissions_permissions_id`, `role_role_id`),
  INDEX `fk_permissions_has_role_role1_idx` (`role_role_id` ASC) VISIBLE,
  INDEX `fk_permissions_has_role_permissions1_idx` (`permissions_permissions_id` ASC) VISIBLE,
  CONSTRAINT `fk_permissions_has_role_permissions1`
    FOREIGN KEY (`permissions_permissions_id`)
    REFERENCES `ct_trans`.`permissions` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_permissions_has_role_role1`
    FOREIGN KEY (`role_role_id`)
    REFERENCES `ct_trans`.`role` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`employe_permissions`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`employe_permissions` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`employe_permissions` (
  `employe_employe_id` INT NOT NULL,
  `permissions_permissions_id` INT NOT NULL,
  PRIMARY KEY (`employe_employe_id`, `permissions_permissions_id`),
  INDEX `fk_employe_has_permissions_permissions1_idx` (`permissions_permissions_id` ASC) VISIBLE,
  INDEX `fk_employe_has_permissions_employe1_idx` (`employe_employe_id` ASC) VISIBLE,
  CONSTRAINT `fk_employe_has_permissions_employe1`
    FOREIGN KEY (`employe_employe_id`)
    REFERENCES `ct_trans`.`employe` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_employe_has_permissions_permissions1`
    FOREIGN KEY (`permissions_permissions_id`)
    REFERENCES `ct_trans`.`permissions` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`weekday`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`weekday` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`weekday` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ct_trans`.`calendar`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `ct_trans`.`calendar` ;

CREATE TABLE IF NOT EXISTS `ct_trans`.`calendar` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `start_time` VARCHAR(10) NOT NULL,
  `end_time` VARCHAR(10) NOT NULL,
  `weekday_idweekday` INT NOT NULL,
  `instructor_instructor_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_agenda_weekday1_idx` (`weekday_idweekday` ASC) VISIBLE,
  INDEX `fk_agenda_instructor1_idx` (`instructor_instructor_id` ASC) VISIBLE,
  CONSTRAINT `fk_agenda_weekday1`
    FOREIGN KEY (`weekday_idweekday`)
    REFERENCES `ct_trans`.`weekday` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_agenda_instructor1`
    FOREIGN KEY (`instructor_instructor_id`)
    REFERENCES `ct_trans`.`instructor` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
